Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5075)
@@ -5604,32 +5978,28 @@
 
    END SUBROUTINE var__add_value_i4
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine add a 4D table of integer(4) value in a variable 
-   !> structure. Dimension of the table must be ordered as ('x','y','z','t')
+   !-------------------------------------------------------------------
+   !> @brief This subroutine add a 4D array of integer(8) value in a variable 
+   !> structure. Dimension of the array must be ordered as ('x','y','z','t')
    !
    !> @details 
-   !> indices in the variable where value will be written could be specify if
-   !> start and count table are given.   
-   !>
-   !> @note variable type is forced to INT
-   !
+   !> Optionally, you could specify the type of the variable to be used (default integer(4)),
+   !> and indices of the variable where value will be written with start and count array.
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] kd_value : table of variable value
-   !> @param[in] id_start : start indices of the variable where data values 
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variable structure
+   !> @param[in] kd_value  array of variable value
+   !> @param[in] id_type   type of the variable to be used (default integer(8)) 
+   !> @param[in] id_start  start indices of the variable where data values 
    !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var__add_value_i8(td_var, kd_value, id_start, id_count)
+   !> @param[in] id_count  number of indices selected along each dimension
+   !-------------------------------------------------------------------
+   SUBROUTINE var__add_value_i8(td_var, kd_value, id_type, id_start, id_count)
       IMPLICIT NONE
       ! Argument      
       TYPE(TVAR),                        INTENT(INOUT) :: td_var
       INTEGER(i8), DIMENSION(:,:,:,:),   INTENT(IN)    :: kd_value
+      INTEGER(i4),                       INTENT(IN),   OPTIONAL  :: id_type
       INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL  :: id_start
       INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL  :: id_count
@@ -5644,7 +6014,7 @@
       !----------------------------------------------------------------
 
-      IF( td_var%i_type == 0 )THEN
-         td_var%i_type=NF90_INT
-      ELSE
+      IF( PRESENT(id_type) )THEN
+         td_var%i_type=id_type
+
          cl_type=''
          SELECT CASE(td_var%i_type)
@@ -5660,5 +6030,5 @@
             cl_type='BYTE'
          END SELECT
-         CALL logger_info("VAR ADD VALUE: "//TRIM(td_var%c_name)//&
+         CALL logger_trace("VAR ADD VALUE: "//TRIM(td_var%c_name)//&
          &                " value will be saved as "//TRIM(cl_type)) 
       ENDIF
@@ -5670,5 +6040,5 @@
 
         CALL logger_error( &
-         &  " ADD VALUE: not enough space to put variable "//&
+         &  " VAR ADD VALUE: not enough space to put variable "//&
          &  TRIM(td_var%c_name)//&
          &  " in variable structure")
@@ -5682,16 +6052,13 @@
 
    END SUBROUTINE var__add_value_i8
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This subroutine remove variable value in a variable 
    !> structure.
-   !
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[inout] td_var variable structure
+   !-------------------------------------------------------------------
    SUBROUTINE var_del_value(td_var)
       IMPLICIT NONE
@@ -5700,6 +6067,6 @@
 
       !----------------------------------------------------------------
-      CALL logger_warn( &
-      &  " DEL VALUE: value in variable "//TRIM(td_var%c_name)//&
+      CALL logger_debug( &
+      &  " VAR DEL VALUE: value in variable "//TRIM(td_var%c_name)//&
       &  ", standard name "//TRIM(td_var%c_stdname)//&
       &  " will be remove ")
@@ -5708,18 +6075,81 @@
 
    END SUBROUTINE var_del_value
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function return the variable id, in a table of variable
-   !> structure,  given variable name or standard name 
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function return the variable index, in a array of variable
+   !> structure,  given variable name or standard name. 
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var : table of variable structure
-   !> @param[in] cd_name : variable name
-   !> @param[in] cd_stdname : variable standard name
-   !> @return variable id in table of variable structure (0 if not found)
-   !-------------------------------------------------------------------
-   !> @code
+   !> - September, 2014- Initial Version
+   !>
+   !> @param[in] td_var       array of variable structure
+   !> @param[in] cd_name      variable name
+   !> @param[in] cd_stdname   variable standard name
+   !> @return variable index in array of variable structure (0 if not found)
+   !-------------------------------------------------------------------
+   INTEGER(i4) FUNCTION var_get_index(td_var, cd_name, cd_stdname)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TVAR)      , DIMENSION(:), INTENT(IN) :: td_var
+      CHARACTER(LEN=*),               INTENT(IN) :: cd_name
+      CHARACTER(LEN=*),               INTENT(IN), OPTIONAL :: cd_stdname
+
+      ! local variable
+      INTEGER(i4) :: il_size
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      var_get_index=0
+      il_size=SIZE(td_var(:))
+
+      ! check if variable is in array of variable structure
+      DO ji=1,il_size
+         ! look for variable name
+         IF( fct_lower(td_var(ji)%c_name) == fct_lower(cd_name) )THEN
+         
+            var_get_index=ji
+            EXIT
+
+         ! look for variable standard name
+         ELSE IF( fct_lower(td_var(ji)%c_stdname) == fct_lower(cd_name) .AND.&
+         &    TRIM(fct_lower(td_var(ji)%c_stdname)) /= '' )THEN
+            
+            var_get_index=ji
+            EXIT
+
+         ELSE IF( PRESENT(cd_stdname) )THEN 
+            IF( fct_lower(td_var(ji)%c_stdname) == fct_lower(cd_stdname) .AND.&
+            &    TRIM(fct_lower(td_var(ji)%c_stdname)) /= '' )THEN
+            
+               var_get_index=ji
+               EXIT
+            ENDIF
+
+         ! look for variable longname
+         ELSE IF( fct_lower(td_var(ji)%c_longname) == fct_lower(cd_name) .AND.&
+         &    TRIM(fct_lower(td_var(ji)%c_longname)) /= '' )THEN
+            
+            var_get_index=ji
+            EXIT
+
+         ENDIF
+
+      ENDDO
+
+   END FUNCTION var_get_index
+   !-------------------------------------------------------------------
+   !> @brief This function return the variable id, 
+   !> given variable name or standard name. 
+   !>
+   !> @warning only variable read from file, have an id.
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_var       array of variable structure
+   !> @param[in] cd_name      variable name
+   !> @param[in] cd_stdname   variable standard name
+   !> @return variable id in array of variable structure (0 if not found)
+   !-------------------------------------------------------------------
    INTEGER(i4) FUNCTION var_get_id(td_var, cd_name, cd_stdname)
       IMPLICIT NONE
@@ -5738,10 +6168,10 @@
       il_size=SIZE(td_var(:))
 
-      ! check if variable is in table of variable structure
+      ! check if variable is in array of variable structure
       DO ji=1,il_size
          ! look for variable name
          IF( fct_lower(td_var(ji)%c_name) == fct_lower(cd_name) )THEN
          
-            var_get_id=ji
+            var_get_id=td_var(ji)%i_id
             EXIT
 
@@ -5749,7 +6179,6 @@
          ELSE IF( fct_lower(td_var(ji)%c_stdname) == fct_lower(cd_name) .AND.&
          &    TRIM(fct_lower(td_var(ji)%c_stdname)) /= '' )THEN
-         !&    TRIM(ADJUSTL(cd_stdname)) /= 'unknown' )THEN
             
-            var_get_id=ji
+            var_get_id=td_var(ji)%i_id
             EXIT
 
@@ -5757,7 +6186,6 @@
             IF( fct_lower(td_var(ji)%c_stdname) == fct_lower(cd_stdname) .AND.&
             &    TRIM(fct_lower(td_var(ji)%c_stdname)) /= '' )THEN
-            !&    TRIM(ADJUSTL(cd_stdname)) /= 'unknown' )THEN
             
-               var_get_id=ji
+               var_get_id=td_var(ji)%i_id
                EXIT
             ENDIF
@@ -5767,18 +6195,14 @@
 
    END FUNCTION var_get_id
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This function return the mask of variable, given variable structure 
-   !> @detail
-   !> 
-   !
+   !> This function return the mask 3D of variable, given variable structure.
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var : table of variable structure
-   !> @return variable id in table of variable structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_var array of variable structure
+   !> @return variable mask(3D)
+   !-------------------------------------------------------------------
    FUNCTION var_get_mask(td_var)
       IMPLICIT NONE
@@ -5787,7 +6211,7 @@
 
       ! function
-      !INTEGER(i4), DIMENSION(:,:), POINTER :: var_get_mask
       INTEGER(i4), DIMENSION(td_var%t_dim(1)%i_len, &
-      &                      td_var%t_dim(2)%i_len) :: var_get_mask
+      &                      td_var%t_dim(2)%i_len, &
+      &                      td_var%t_dim(3)%i_len ) :: var_get_mask
 
       ! local variable
@@ -5795,39 +6219,45 @@
       IF( ASSOCIATED(td_var%d_value) )THEN
 
-         CALL logger_trace( "GET MASK: create mask from variable "//&
+         CALL logger_trace( "VAR GET MASK: create mask from variable "//&
          &               TRIM(td_var%c_name) )
-         var_get_mask(:,:)=1
-         WHERE( td_var%d_value(:,:,1,1) == td_var%d_fill )
-            var_get_mask(:,:)=0
+         var_get_mask(:,:,:)=1
+         WHERE( td_var%d_value(:,:,:,1) == td_var%d_fill )
+            var_get_mask(:,:,:)=0
          ENDWHERE
 
       ELSE
-         CALL logger_error("GET MASK: variable value not define.")
+         CALL logger_error("VAR GET MASK: variable value not define.")
       ENDIF
    END FUNCTION var_get_mask
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine change Fill Value of the variable to 
-   !> standard NETCDF Fill Value 
-   !> @detail
+   !> This subroutine change FillValue of the variable to 
+   !> standard NETCDF FillValue. 
+   !>
+   !> @details
+   !> optionally, you could specify a dummy _FillValue to be used
    !> 
-   !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : table of variable structure
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var_chg_FillValue(td_var)
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var array of variable structure
+   !> @param[in] dd_fill _FillValue to be used
+   !-------------------------------------------------------------------
+   SUBROUTINE var_chg_FillValue(td_var, dd_fill)
       IMPLICIT NONE
       ! Argument      
       TYPE(TVAR), INTENT(INOUT) :: td_var
+      REAL(dp)  , INTENT(IN)   , OPTIONAL :: dd_fill
 
       ! local variable
       TYPE(TATT) :: tl_att
+
+      INTEGER(i1) :: bl_fill
+      INTEGER(i2) :: sl_fill
+      INTEGER(i4) :: il_fill
+      REAL(sp)    :: rl_fill
       !----------------------------------------------------------------
 
-      CALL logger_debug( "CHG FILL VALUE: change _FillValue in variable "//&
+      CALL logger_trace( "VAR CHG FILL VALUE: change _FillValue in variable "//&
       &  TRIM(td_var%c_name) )
 
@@ -5836,15 +6266,37 @@
 
          CASE(NF90_BYTE)
-            tl_att=att_init('_FillValue',NF90_FILL_BYTE)
+            IF( PRESENT(dd_fill) )THEN
+               bl_fill=INT(dd_fill,i1)
+               tl_att=att_init('_FillValue',bl_fill)
+            ELSE
+               tl_att=att_init('_FillValue',NF90_FILL_BYTE)
+            ENDIF
          CASE(NF90_SHORT)
-            tl_att=att_init('_FillValue',NF90_FILL_SHORT)
+            IF( PRESENT(dd_fill) )THEN
+               sl_fill=INT(dd_fill,i2)
+               tl_att=att_init('_FillValue',sl_fill)
+            ELSE
+               tl_att=att_init('_FillValue',NF90_FILL_SHORT)
+            ENDIF
          CASE(NF90_INT)
-            tl_att=att_init('_FillValue',NF90_FILL_INT)
+            IF( PRESENT(dd_fill) )THEN
+               il_fill=INT(dd_fill,i4)
+               tl_att=att_init('_FillValue',il_fill)
+            ELSE
+               tl_att=att_init('_FillValue',NF90_FILL_INT)
+            ENDIF
          CASE(NF90_FLOAT)
-            tl_att=att_init('_FillValue',NF90_FILL_FLOAT)
-         CASE(NF90_DOUBLE)
-            tl_att=att_init('_FillValue',NF90_FILL_DOUBLE)
-         CASE DEFAULT
-            tl_att=att_init('_FillValue',NF90_FILL_DOUBLE)
+            IF( PRESENT(dd_fill) )THEN
+               rl_fill=REAL(dd_fill,sp)
+               tl_att=att_init('_FillValue',rl_fill)
+            ELSE
+               tl_att=att_init('_FillValue',NF90_FILL_FLOAT)
+            ENDIF
+         CASE DEFAULT ! NF90_DOUBLE
+            IF( PRESENT(dd_fill) )THEN
+               tl_att=att_init('_FillValue',dd_fill)
+            ELSE
+               tl_att=att_init('_FillValue',NF90_FILL_DOUBLE)
+            ENDIF
 
       END SELECT
@@ -5860,19 +6312,18 @@
       CALL var_move_att(td_var, tl_att)
 
+      ! clean
+      CALL att_clean(tl_att)
+
    END SUBROUTINE var_chg_FillValue
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine read variable configuration file, fill and save 
-   !> a global table of variable structure with extra information :tg_varextra.
+   !> This subroutine read variable configuration file. And save 
+   !> global array of variable structure with extra information: tg_varextra.
    !> 
-   !> @details 
-   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_file : configuration file of variable
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_file   configuration file of variable
+   !-------------------------------------------------------------------
    SUBROUTINE var_def_extra( cd_file )
       IMPLICIT NONE
@@ -5894,5 +6345,8 @@
       !----------------------------------------------------------------
 
-      IF( ALLOCATED(tg_varextra) ) DEALLOCATE(tg_varextra)
+      IF( ALLOCATED(tg_varextra) )THEN
+         CALL var_clean(tg_varextra(:))
+         DEALLOCATE(tg_varextra)
+      ENDIF
 
       ! read config variable file
@@ -5901,7 +6355,7 @@
          
          ! get number of variable to be read
+
          il_fileid=fct_getunit()
-
-         CALL logger_debug("VAR DEF EXTRA: open "//TRIM(cd_file))
+         CALL logger_trace("VAR DEF EXTRA: open "//TRIM(cd_file))
          OPEN( il_fileid, FILE=TRIM(cd_file), &
          &                FORM='FORMATTED',   &
@@ -5922,5 +6376,5 @@
 
          ! search line do not beginning with comment character
-            IF( SCAN( TRIM(fct_concat(cg_com(:))) ,cl_line(1:1)) == 0 )THEN
+            IF( SCAN( TRIM(fct_concat(cp_com(:))) ,cl_line(1:1)) == 0 )THEN
                il_nvar=il_nvar+1
             ENDIF
@@ -5941,7 +6395,8 @@
          ELSE
             CALL logger_info("VAR DEF EXTRA: "//TRIM(fct_str(il_nvar))//&
-            &            " variable to be read on varaible config file")
-
-            CALL logger_debug("VAR DEF EXTRA: rewind "//TRIM(cd_file))
+            &            " variable to be read on varaible config file"//&
+            &            TRIM(cd_file))
+
+            CALL logger_trace("VAR DEF EXTRA: rewind "//TRIM(cd_file))
             REWIND( il_fileid, IOSTAT=il_status)
             CALL fct_err(il_status)
@@ -5958,5 +6413,5 @@
             DO WHILE( il_status == 0 )
 
-               IF( SCAN( TRIM(fct_concat(cg_com(:))) ,cl_line(1:1)) == 0 )THEN
+               IF( SCAN( TRIM(fct_concat(cp_com(:))) ,cl_line(1:1)) == 0 )THEN
                   tg_varextra(ji)%i_id      = ji
                   tg_varextra(ji)%c_name    =TRIM(fct_split(cl_line,1))
@@ -5996,28 +6451,28 @@
 
    END SUBROUTINE var_def_extra
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
    !> This subroutine add variable information get from namelist in 
-   !> global table of variable structure with extra information :tg_varextra.
+   !> global array of variable structure with extra information: tg_varextra.
    !> 
    !> @details 
-   !> string character format must be : "varname:interp|filter|extrap"
+   !> string character format must be : <br/>
+   !> "varname:interp; filter; extrap; > min; < max"<br/>
    !> you could specify only interpolation, filter or extrapolation method, 
-   !> or two whatever the order. you could find more
-   !> information about available method in interpolation, filter, and
-   !> extrapolation module. Here you cuold find some exemples: 
-   !> cn_varinfo='Bathymetry:2*hamming(2,3)'
-   !> cn_varinfo='votemper:cubic|dist_weight'
-   !>
-   !> @note If you do not specify one method which is required, default one is
+   !> whatever the order. you could find more
+   !> information about available method in \ref interp, \ref filter, and
+   !> \ref extrap module.<br/>
+   !> Examples: 
+   !> cn_varinfo='Bathymetry:2*hamming(2,3); > 10.'
+   !> cn_varinfo='votemper:cubic; dist_weight; <40.'
+   !>
+   !> @note If you do not specify a method which is required, default one is
    !> apply.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_varinfo : variable information from namelist
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_varinfo   variable information from namelist
+   !-------------------------------------------------------------------
    SUBROUTINE var_chg_extra( cd_varinfo )
       IMPLICIT NONE
@@ -6032,5 +6487,5 @@
       CHARACTER(LEN=lc), DIMENSION(5)              :: cl_filter
 
-      INTEGER(i4)                                  :: il_varid
+      INTEGER(i4)                                  :: il_ind
       INTEGER(i4)                                  :: il_nvar
 
@@ -6044,91 +6499,103 @@
       !----------------------------------------------------------------
 
-      ji=1
-      DO WHILE( TRIM(cd_varinfo(ji)) /= '' )
-
-         cl_name  =fct_lower(fct_split(cd_varinfo(ji),1,':'))
-         cl_method=fct_split(cd_varinfo(ji),2,':')
-
-         dl_min=var__get_min(cl_name, cl_method)
-         dl_max=var__get_max(cl_name, cl_method)
-         cl_interp(:)=var__get_interp(cl_name, cl_method)
-         cl_extrap(:)=var__get_extrap(cl_name, cl_method)
-         cl_filter(:)=var__get_filter(cl_name, cl_method)
-
-         il_varid=var_get_id(tg_varextra(:), TRIM(cl_name))
-         IF( il_varid /= 0 )THEN
-            IF( dl_min /= dg_fill ) tg_varextra(il_varid)%d_min=dl_min
-            IF( dl_max /= dg_fill ) tg_varextra(il_varid)%d_max=dl_max
-            IF(cl_interp(1)/='') tg_varextra(il_varid)%c_interp(:)=cl_interp(:)
-            IF(cl_extrap(1)/='') tg_varextra(il_varid)%c_extrap(:)=cl_extrap(:)
-            IF(cl_filter(1)/='') tg_varextra(il_varid)%c_filter(:)=cl_filter(:)
-         ELSE
-
-            IF( ALLOCATED(tg_varextra) )THEN
-               il_nvar=SIZE(tg_varextra(:))
-               ! save older variable
-               ALLOCATE( tl_varextra(il_nvar) )
-               tl_varextra(:)=tg_varextra(:)
-
-               DEALLOCATE(tg_varextra)
-               ALLOCATE( tg_varextra(il_nvar+1) )
-               
-               tg_varextra(1:il_nvar)=tl_varextra(:)
-               DEALLOCATE(tl_varextra)
-
+      IF( ALLOCATED(tg_varextra) )THEN
+         ji=1
+         DO WHILE( TRIM(cd_varinfo(ji)) /= '' )
+
+            cl_name  =fct_lower(fct_split(cd_varinfo(ji),1,':'))
+            cl_method=fct_split(cd_varinfo(ji),2,':')
+
+            dl_min=var__get_min(cl_name, cl_method)
+            dl_max=var__get_max(cl_name, cl_method)
+            cl_interp(:)=var__get_interp(cl_name, cl_method)
+            cl_extrap(:)=var__get_extrap(cl_name, cl_method)
+            cl_filter(:)=var__get_filter(cl_name, cl_method)
+
+            il_ind=var_get_index(tg_varextra(:), TRIM(cl_name))
+            IF( il_ind /= 0 )THEN
+               IF( dl_min /= dp_fill ) tg_varextra(il_ind)%d_min=dl_min
+               IF( dl_max /= dp_fill ) tg_varextra(il_ind)%d_max=dl_max
+               IF(cl_interp(1)/='') tg_varextra(il_ind)%c_interp(:)=cl_interp(:)
+               IF(cl_extrap(1)/='') tg_varextra(il_ind)%c_extrap(:)=cl_extrap(:)
+               IF(cl_filter(1)/='') tg_varextra(il_ind)%c_filter(:)=cl_filter(:)
             ELSE
 
-               il_varid=0
-               ALLOCATE( tg_varextra(1) )
+               IF( ALLOCATED(tg_varextra) )THEN
+                  il_nvar=SIZE(tg_varextra(:))
+                  ! save older variable
+                  ALLOCATE( tl_varextra(il_nvar) )
+                  tl_varextra(:)=var_copy(tg_varextra(:))
+
+                  CALL var_clean(tg_varextra(:))
+                  DEALLOCATE(tg_varextra)
+                  ALLOCATE( tg_varextra(il_nvar+1) )
+                  
+                  tg_varextra(1:il_nvar)=var_copy(tl_varextra(:))
+
+                  ! clean
+                  CALL var_clean(tl_varextra(:))
+                  DEALLOCATE(tl_varextra)
+
+               ELSE
+
+                  il_nvar=0
+                  ALLOCATE( tg_varextra(1) )
+
+               ENDIF
+
+               ! add new variable
+               il_ind=il_nvar+1
+               tg_varextra(il_ind)=var_init( TRIM(cl_name), &
+               &                               cd_interp=cl_interp(:), &
+               &                               cd_extrap=cl_extrap(:), &
+               &                               cd_filter=cl_filter(:), &
+               &                               dd_min = dl_min, &
+               &                               dd_max = dl_max )
 
             ENDIF
 
-            ! add new variable
-            il_varid=il_nvar+1
-            tg_varextra(il_varid)=var_init( TRIM(cl_name), &
-            &                               cd_interp=cl_interp(:), &
-            &                               cd_extrap=cl_extrap(:), &
-            &                               cd_filter=cl_filter(:), &
-            &                               dd_min = dl_min, &
-            &                               dd_max = dl_max )
-
-         ENDIF
-
-         ji=ji+1
-         CALL logger_trace( "VAR CHG EXTRA: name       "//&
-         &                  TRIM(tg_varextra(il_varid)%c_name) )
-         CALL logger_trace( "VAR CHG EXTRA: interp     "//&
-         &                  TRIM(tg_varextra(il_varid)%c_interp(1)) )         
-         CALL logger_trace( "VAR CHG EXTRA: filter     "//&
-         &                  TRIM(tg_varextra(il_varid)%c_filter(1)) )         
-         CALL logger_trace( "VAR CHG EXTRA: extrap     "//&
-         &                  TRIM(tg_varextra(il_varid)%c_extrap(1)) )
-         IF( tg_varextra(il_varid)%d_min /= dg_fill )THEN
-            CALL logger_trace( "VAR CHG EXTRA: min value  "//&
-            &                  TRIM(fct_str(tg_varextra(il_varid)%d_min)) )
-         ENDIF
-         IF( tg_varextra(il_varid)%d_max /= dg_fill )THEN
-            CALL logger_trace( "VAR CHG EXTRA: max value  "//&
-            &                  TRIM(fct_str(tg_varextra(il_varid)%d_max)) )
-         ENDIF
-      ENDDO
+            ji=ji+1
+            CALL logger_trace( "VAR CHG EXTRA: name       "//&
+            &                  TRIM(tg_varextra(il_ind)%c_name) )
+            CALL logger_trace( "VAR CHG EXTRA: interp     "//&
+            &                  TRIM(tg_varextra(il_ind)%c_interp(1)) )         
+            CALL logger_trace( "VAR CHG EXTRA: filter     "//&
+            &                  TRIM(tg_varextra(il_ind)%c_filter(1)) )         
+            CALL logger_trace( "VAR CHG EXTRA: extrap     "//&
+            &                  TRIM(tg_varextra(il_ind)%c_extrap(1)) )
+            IF( tg_varextra(il_ind)%d_min /= dp_fill )THEN
+               CALL logger_trace( "VAR CHG EXTRA: min value  "//&
+               &                  TRIM(fct_str(tg_varextra(il_ind)%d_min)) )
+            ENDIF
+            IF( tg_varextra(il_ind)%d_max /= dp_fill )THEN
+               CALL logger_trace( "VAR CHG EXTRA: max value  "//&
+               &                  TRIM(fct_str(tg_varextra(il_ind)%d_max)) )
+            ENDIF
+         ENDDO
+      ENDIF
 
    END SUBROUTINE var_chg_extra
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine read matrix value from character string
+   !> This subroutine read matrix value from character string in namelist
    !> and fill variable strucutre value.
-
-   !> @detail
-   !> 
-   !
+   !>
+   !> @details
+   !> to split matrix, separator use are:<br/>
+   !> - ',' for line
+   !> - '/' for row
+   !> - '\' for level<br/>
+   !> Example:<br/>
+   !> 3,2,3/1,4,5  => 
+   !> @f$ \left( \begin{array}{ccc}
+   !> 3 & 2 & 3 \\
+   !> 1 & 4 & 5 \end{array} \right) @f$
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] cd_matrix : matrix value
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variable structure
+   !> @param[in] cd_matrix matrix value
+   !-------------------------------------------------------------------
    SUBROUTINE var_read_matrix(td_var, cd_matrix)
       IMPLICIT NONE
@@ -6138,5 +6605,5 @@
 
       ! local variable
-      CHARACTER(LEN=lc)                                  :: cl_table
+      CHARACTER(LEN=lc)                                  :: cl_array
       CHARACTER(LEN=lc)                                  :: cl_line
       CHARACTER(LEN=lc)                                  :: cl_elt
@@ -6158,13 +6625,13 @@
 
          !1- read matrix
-         ALLOCATE( dl_matrix(ig_maxmtx, ig_maxmtx, ig_maxmtx) )
+         ALLOCATE( dl_matrix(ip_maxmtx, ip_maxmtx, ip_maxmtx) )
          dl_matrix(:,:,:)=td_var%d_fill
 
          jk=1
-         cl_table=fct_split(TRIM(cd_matrix),jk,'\ ')
-         CALL logger_debug("VAR MATRIX table "//TRIM(cl_table) )
-         DO WHILE( TRIM(cl_table) /= '' )
+         cl_array=fct_split(TRIM(cd_matrix),jk,'\ ')
+         CALL logger_debug("VAR MATRIX array "//TRIM(cl_array) )
+         DO WHILE( TRIM(cl_array) /= '' )
             jj=1
-            cl_line=fct_split(TRIM(cl_table),jj,'/')
+            cl_line=fct_split(TRIM(cl_array),jj,'/')
             CALL logger_debug("VAR MATRIX line "//TRIM(cl_line) )
             DO WHILE( TRIM(cl_line) /= '' )
@@ -6179,10 +6646,10 @@
                ENDDO
                jj=jj+1
-               cl_line=fct_split(TRIM(cl_table),jj,'/')
+               cl_line=fct_split(TRIM(cl_array),jj,'/')
                CALL logger_debug("VAR MATRIX line "//TRIM(cl_line) )
             ENDDO
             jk=jk+1
-            cl_table=fct_split(TRIM(cd_matrix),jk,'\ ')
-            CALL logger_debug("VAR MATRIX table "//TRIM(cl_table) )
+            cl_array=fct_split(TRIM(cd_matrix),jk,'\ ')
+            CALL logger_debug("VAR MATRIX array "//TRIM(cl_array) )
          ENDDO
 
@@ -6200,9 +6667,10 @@
          
          CALL var_add_dim(td_var, tl_dim(:))
+         ! clean
          CALL dim_clean(tl_dim)
          DEALLOCATE( tl_dim )
 
          IF( ASSOCIATED(td_var%d_value) ) DEALLOCATE(td_var%d_value)
-         CALL var_add_value(td_var, dl_value(:,:,:,:))
+         CALL var_add_value(td_var, dl_value(:,:,:,:), id_type=NF90_FLOAT)
 
          DEALLOCATE( dl_value )
@@ -6210,17 +6678,17 @@
 
    END SUBROUTINE var_read_matrix
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine add extra information in variable structure
+   !> This subroutine add extra information in variable structure.
    !> 
    !> @details 
-   !>
+   !> if variable name is informed in global array of variable structure (tg_varextra).
+   !> fill empty parameter on variable structure.
+   !> 
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[inout] td_var variable structure
+   !-------------------------------------------------------------------
    SUBROUTINE var__get_extra( td_var )
       IMPLICIT NONE
@@ -6229,5 +6697,5 @@
 
       ! local variable
-      INTEGER(i4)       :: il_varid
+      INTEGER(i4)       :: il_ind
       TYPE(TATT)        :: tl_att
 
@@ -6237,18 +6705,20 @@
       IF( ALLOCATED(tg_varextra) )THEN
 
-         il_varid=var_get_id( tg_varextra(:), TRIM(td_var%c_name),  &
-                                              TRIM(td_var%c_stdname))
-         IF( il_varid /= 0 )THEN
+         il_ind=var_get_index( tg_varextra(:), TRIM(td_var%c_name),  &
+                                               TRIM(td_var%c_stdname))
+         IF( il_ind /= 0 )THEN
 
             ! name
             IF( TRIM(td_var%c_name) == '' .AND. &
-            &   TRIM(tg_varextra(il_varid)%c_name) /= '' )THEN
-               td_var%c_name=TRIM(tg_varextra(il_varid)%c_name)
+            &   TRIM(tg_varextra(il_ind)%c_name) /= '' )THEN
+               td_var%c_name=TRIM(tg_varextra(il_ind)%c_name)
             ENDIF
 
             ! standard name
-            IF( TRIM(td_var%c_stdname) == '' .AND. &
-            &   TRIM(tg_varextra(il_varid)%c_stdname) /= ''  )THEN
-               td_var%c_stdname=TRIM(tg_varextra(il_varid)%c_stdname)
+            IF( TRIM(tg_varextra(il_ind)%c_stdname) /= '' .AND. &
+            &   ( TRIM(td_var%c_stdname) == '' .OR. &
+            &     TRIM(tg_varextra(il_ind)%c_stdname) /= &
+            &     TRIM(td_var%c_stdname) ) )THEN
+               td_var%c_stdname=TRIM(tg_varextra(il_ind)%c_stdname)
                ! create attibute
                tl_att=att_init('standard_name',TRIM(td_var%c_stdname))
